Name:		SL_enable_serialconsole
Version:	4.2
Release:	1%{?dist}
Summary:	Script to enable serial console in all the right places.
Vendor:		Scientific Linux
Packager:	Pat Riehecky

Group:		SL
License:	GPL
URL:		http://www.scientificlinux.org/
Source0:	SL_enable_serialconsole.tar.gz
BuildArch:	noarch
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires:	bash
Requires:	bash coreutils sed grub2
Provides:	SL_enable_serialconsole-96

# Only one at a time
Conflicts:	SL_enable_serialconsole-96
Conflicts:	SL_enable_serialconsole-192
Conflicts:	SL_enable_serialconsole-384
Conflicts:	SL_enable_serialconsole-1152

%description
This package will install (and automatically run) the 'serialconsole' script. This script makes all the changes necessary to send console output to both the serial port and the screen. This also creates a login prompt on the serial port and allows root to login at this prompt.

This package only works with grub.
You can only have one SL_enable_serialconsole installed at a time.  Having extras will cause unknown behavior, as will switching between them with one command.  To change versions fully remove one package then install the other.

%package 96
Summary:	Script to enable serial console in all the right places.
Group:		SL
Requires:	bash coreutils sed grub2
Conflicts:	SL_enable_serialconsole
Conflicts:	SL_enable_serialconsole-192
Conflicts:	SL_enable_serialconsole-384
Conflicts:	SL_enable_serialconsole-1152
%description 96
This package will install (and automatically run) the 'serialconsole' script. This script makes all the changes necessary to send console output to both the serial port and the screen. This also creates a login prompt on the serial port and allows root to login at this prompt.

This package only works with grub.
You can only have one SL_enable_serialconsole installed at a time.  Having extras will cause unknown behavior, as will switching between them with one command.  To change versions fully remove one package then install the other.

%package 192
Summary:	Script to enable serial console in all the right places.
Group:		SL
Requires:	bash coreutils sed grub2
Conflicts:	SL_enable_serialconsole
Conflicts:	SL_enable_serialconsole-96
Conflicts:	SL_enable_serialconsole-384
Conflicts:	SL_enable_serialconsole-1152
%description 192
This package will install (and automatically run) the 'serialconsole' script. This script makes all the changes necessary to send console output to both the serial port and the screen. This also creates a login prompt on the serial port and allows root to login at this prompt.

This package only works with grub.
You can only have one SL_enable_serialconsole installed at a time.  Having extras will cause unknown behavior, as will switching between them with one command.  To change versions fully remove one package then install the other.

%package 384
Summary:	Script to enable serial console in all the right places.
Group:		SL
Requires:	bash coreutils sed grub2
Conflicts:	SL_enable_serialconsole
Conflicts:	SL_enable_serialconsole-96
Conflicts:	SL_enable_serialconsole-192
Conflicts:	SL_enable_serialconsole-1152
%description 384
This package will install (and automatically run) the 'serialconsole' script. This script makes all the changes necessary to send console output to both the serial port and the screen. This also creates a login prompt on the serial port and allows root to login at this prompt.

This package only works with grub.
You can only have one SL_enable_serialconsole installed at a time.  Having extras will cause unknown behavior, as will switching between them with one command.  To change versions fully remove one package then install the other.

%package 1152
Summary:	Script to enable serial console in all the right places.
Group:		SL
Requires:	bash coreutils sed grub2
Conflicts:	SL_enable_serialconsole
Conflicts:	SL_enable_serialconsole-96
Conflicts:	SL_enable_serialconsole-192
Conflicts:	SL_enable_serialconsole-384
%description 1152
This package will install (and automatically run) the 'serialconsole' script. This script makes all the changes necessary to send console output to both the serial port and the screen. This also creates a login prompt on the serial port and allows root to login at this prompt.

This package only works with grub.
You can only have one SL_enable_serialconsole installed at a time.  Having extras will cause unknown behavior, as will switching between them with one command.  To change versions fully remove one package then install the other.

%prep
%setup -q -n SL_enable_serialconsole

%install
rm -rf $RPM_BUILD_ROOT
install -D -m 640 README ${RPM_BUILD_ROOT}/%{_docdir}/SL_enable_serialconsole/README
cp serialconsole-* ${RPM_BUILD_ROOT}/%{_docdir}/SL_enable_serialconsole/
chmod 640 ${RPM_BUILD_ROOT}/%{_docdir}/SL_enable_serialconsole/serialconsole-*

%clean
rm -rf $RPM_BUILD_ROOT

#############################################################
%files
%defattr(640,root,root,751)
%doc %{_docdir}/SL_enable_serialconsole/*

%post
grep GRUB_TIMEOUT /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "GRUB_TIMEOUT=5" >> /etc/sysconfig/grub
fi

# The default is /dev/ttyS0 with a speed of 9600
grep SL_enable_serialconsole/serialconsole-96 /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "source %{_docdir}/SL_enable_serialconsole/serialconsole-96" >> /etc/sysconfig/grub
fi

if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

%preun
# Remove the serial configuration as we remove the RPM
if [[ "$1" == '0' ]]; then # uninstall
    grep -v SL_enable_serialconsole/serialconsole-96 /etc/sysconfig/grub > /tmp/SL_enable_serialconsole.uninstall
    cat /tmp/SL_enable_serialconsole.uninstall > /etc/sysconfig/grub
fi
if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

#############################################################
%files 96
%defattr(640,root,root,751)
%doc %{_docdir}/SL_enable_serialconsole/*

%post 96
grep GRUB_TIMEOUT /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "GRUB_TIMEOUT=5" >> /etc/sysconfig/grub
fi

grep SL_enable_serialconsole/serialconsole-96 /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "source %{_docdir}/SL_enable_serialconsole/serialconsole-96" >> /etc/sysconfig/grub
fi

if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

%preun 96
# Remove the serial configuration as we remove the RPM
if [[ "$1" == '0' ]]; then # uninstall
    grep -v SL_enable_serialconsole/serialconsole-96 /etc/sysconfig/grub > /tmp/SL_enable_serialconsole.uninstall
    cat /tmp/SL_enable_serialconsole.uninstall > /etc/sysconfig/grub
fi
if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

#############################################################
%files 192
%defattr(640,root,root,751)
%doc %{_docdir}/SL_enable_serialconsole/*

%post 192
grep GRUB_TIMEOUT /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "GRUB_TIMEOUT=5" >> /etc/sysconfig/grub
fi

grep SL_enable_serialconsole/serialconsole-192 /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "source %{_docdir}/SL_enable_serialconsole/serialconsole-192" >> /etc/sysconfig/grub
fi

if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

%preun 192
# Remove the serial configuration as we remove the RPM
if [[ "$1" == '0' ]]; then # uninstall
    grep -v SL_enable_serialconsole/serialconsole-192 /etc/sysconfig/grub > /tmp/SL_enable_serialconsole.uninstall
    cat /tmp/SL_enable_serialconsole.uninstall > /etc/sysconfig/grub
fi
if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

#############################################################
%files 384
%defattr(640,root,root,751)
%doc %{_docdir}/SL_enable_serialconsole/*

%post 384
grep GRUB_TIMEOUT /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "GRUB_TIMEOUT=5" >> /etc/sysconfig/grub
fi

grep SL_enable_serialconsole/serialconsole-384 /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "source %{_docdir}/SL_enable_serialconsole/serialconsole-384" >> /etc/sysconfig/grub
fi

if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

%preun 384
# Remove the serial configuration as we remove the RPM
if [[ "$1" == '0' ]]; then # uninstall
    grep -v SL_enable_serialconsole/serialconsole-384 /etc/sysconfig/grub > /tmp/SL_enable_serialconsole.uninstall
    cat /tmp/SL_enable_serialconsole.uninstall > /etc/sysconfig/grub
fi
if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

#############################################################
%files 1152
%defattr(640,root,root,751)
%doc %{_docdir}/SL_enable_serialconsole/*

%post 1152
grep GRUB_TIMEOUT /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "GRUB_TIMEOUT=5" >> /etc/sysconfig/grub
fi

grep SL_enable_serialconsole/serialconsole-1152 /etc/sysconfig/grub >/dev/null
if [[ $? -ne 0 ]]; then
    echo "source %{_docdir}/SL_enable_serialconsole/serialconsole-1152" >> /etc/sysconfig/grub
fi

if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

%preun 1152
# Remove the serial configuration as we remove the RPM
if [[ "$1" == '0' ]]; then # uninstall
    grep -v SL_enable_serialconsole/serialconsole-1152 /etc/sysconfig/grub > /tmp/SL_enable_serialconsole.uninstall
    cat /tmp/SL_enable_serialconsole.uninstall > /etc/sysconfig/grub
fi
if [[ -d /sys/firmware/efi ]]; then
    grub2-mkconfig > /etc/grub2-efi.cfg
fi
grub2-mkconfig > /etc/grub2.cfg

#############################################################
%changelog
* Mon Sep 30 2013 Pat Riehecky <riehecky@fnal.gov> 4.2-1
- updated for grub2 on SL7
- all 'legacy' code/tools removed as they no longer work on SL7

* Mon Jan 30 2012 Pat Riehecky <riehecky@fnal.gov> 4.1-1
- added '-r' option to script for removal of the configuration
- now removes configuration when uninstalled
- Switched to augeas based configuration
- The old script can be found in the %doc folder
- removed support for non-grub bootloaders as none are avalible for SL6
- a number of SPEC file changes to make things cleaner

* Mon Aug 23 2010 Troy Dawson <dawson@fnal.gov> 4.0-1
- Changed the script to only work with grub, not lilo or efi
- For Fedora 13, RHEL 6 (or it's derivatives) or newer due to
  the startup changes in

